//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------

namespace OpenMMNET {

public class CustomIntegrator : Integrator {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;

  internal CustomIntegrator(global::System.IntPtr cPtr, bool cMemoryOwn) : base(OpenMMSwigPINVOKE.CustomIntegrator_SWIGUpcast(cPtr), cMemoryOwn) {
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(CustomIntegrator obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~CustomIntegrator() {
    Dispose();
  }

  public override void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          OpenMMSwigPINVOKE.delete_CustomIntegrator(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
      base.Dispose();
    }
  }

  public CustomIntegrator(double stepSize) : this(OpenMMSwigPINVOKE.new_CustomIntegrator(stepSize), true) {
  }

  public int getNumGlobalVariables() {
    int ret = OpenMMSwigPINVOKE.CustomIntegrator_getNumGlobalVariables(swigCPtr);
    return ret;
  }

  public int getNumPerDofVariables() {
    int ret = OpenMMSwigPINVOKE.CustomIntegrator_getNumPerDofVariables(swigCPtr);
    return ret;
  }

  public int getNumComputations() {
    int ret = OpenMMSwigPINVOKE.CustomIntegrator_getNumComputations(swigCPtr);
    return ret;
  }

  public int getNumTabulatedFunctions() {
    int ret = OpenMMSwigPINVOKE.CustomIntegrator_getNumTabulatedFunctions(swigCPtr);
    return ret;
  }

  public int addGlobalVariable(string name, double initialValue) {
    int ret = OpenMMSwigPINVOKE.CustomIntegrator_addGlobalVariable(swigCPtr, name, initialValue);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public string getGlobalVariableName(int index) {
    string ret = OpenMMSwigPINVOKE.CustomIntegrator_getGlobalVariableName(swigCPtr, index);
    return ret;
  }

  public int addPerDofVariable(string name, double initialValue) {
    int ret = OpenMMSwigPINVOKE.CustomIntegrator_addPerDofVariable(swigCPtr, name, initialValue);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public string getPerDofVariableName(int index) {
    string ret = OpenMMSwigPINVOKE.CustomIntegrator_getPerDofVariableName(swigCPtr, index);
    return ret;
  }

  public double getGlobalVariable(int index) {
    double ret = OpenMMSwigPINVOKE.CustomIntegrator_getGlobalVariable(swigCPtr, index);
    return ret;
  }

  public double getGlobalVariableByName(string name) {
    double ret = OpenMMSwigPINVOKE.CustomIntegrator_getGlobalVariableByName(swigCPtr, name);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public void setGlobalVariable(int index, double value) {
    OpenMMSwigPINVOKE.CustomIntegrator_setGlobalVariable(swigCPtr, index, value);
  }

  public void setGlobalVariableByName(string name, double value) {
    OpenMMSwigPINVOKE.CustomIntegrator_setGlobalVariableByName(swigCPtr, name, value);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void getPerDofVariable(int index, OpenMMVectorVec3 values) {
    OpenMMSwigPINVOKE.CustomIntegrator_getPerDofVariable(swigCPtr, index, OpenMMVectorVec3.getCPtr(values));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void getPerDofVariableByName(string name, OpenMMVectorVec3 values) {
    OpenMMSwigPINVOKE.CustomIntegrator_getPerDofVariableByName(swigCPtr, name, OpenMMVectorVec3.getCPtr(values));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setPerDofVariable(int index, OpenMMVectorVec3 values) {
    OpenMMSwigPINVOKE.CustomIntegrator_setPerDofVariable(swigCPtr, index, OpenMMVectorVec3.getCPtr(values));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setPerDofVariableByName(string name, OpenMMVectorVec3 values) {
    OpenMMSwigPINVOKE.CustomIntegrator_setPerDofVariableByName(swigCPtr, name, OpenMMVectorVec3.getCPtr(values));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public int addComputeGlobal(string variable, string expression) {
    int ret = OpenMMSwigPINVOKE.CustomIntegrator_addComputeGlobal(swigCPtr, variable, expression);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public int addComputePerDof(string variable, string expression) {
    int ret = OpenMMSwigPINVOKE.CustomIntegrator_addComputePerDof(swigCPtr, variable, expression);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public int addComputeSum(string variable, string expression) {
    int ret = OpenMMSwigPINVOKE.CustomIntegrator_addComputeSum(swigCPtr, variable, expression);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public int addConstrainPositions() {
    int ret = OpenMMSwigPINVOKE.CustomIntegrator_addConstrainPositions(swigCPtr);
    return ret;
  }

  public int addConstrainVelocities() {
    int ret = OpenMMSwigPINVOKE.CustomIntegrator_addConstrainVelocities(swigCPtr);
    return ret;
  }

  public int addUpdateContextState() {
    int ret = OpenMMSwigPINVOKE.CustomIntegrator_addUpdateContextState(swigCPtr);
    return ret;
  }

  public int beginIfBlock(string condition) {
    int ret = OpenMMSwigPINVOKE.CustomIntegrator_beginIfBlock(swigCPtr, condition);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public int beginWhileBlock(string condition) {
    int ret = OpenMMSwigPINVOKE.CustomIntegrator_beginWhileBlock(swigCPtr, condition);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public int endBlock() {
    int ret = OpenMMSwigPINVOKE.CustomIntegrator_endBlock(swigCPtr);
    return ret;
  }

  public void getComputationStep(int index, SWIGTYPE_p_OpenMM__CustomIntegrator__ComputationType type, SWIGTYPE_p_std__string variable, SWIGTYPE_p_std__string expression) {
    OpenMMSwigPINVOKE.CustomIntegrator_getComputationStep(swigCPtr, index, SWIGTYPE_p_OpenMM__CustomIntegrator__ComputationType.getCPtr(type), SWIGTYPE_p_std__string.getCPtr(variable), SWIGTYPE_p_std__string.getCPtr(expression));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public int addTabulatedFunction(string name, TabulatedFunction function) {
    int ret = OpenMMSwigPINVOKE.CustomIntegrator_addTabulatedFunction(swigCPtr, name, TabulatedFunction.getCPtr(function));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public TabulatedFunction getTabulatedFunction(int index) {
    TabulatedFunction ret = new TabulatedFunction(OpenMMSwigPINVOKE.CustomIntegrator_getTabulatedFunction__SWIG_0(swigCPtr, index), false);
    return ret;
  }

  public string getTabulatedFunctionName(int index) {
    string ret = OpenMMSwigPINVOKE.CustomIntegrator_getTabulatedFunctionName(swigCPtr, index);
    return ret;
  }

  public string getKineticEnergyExpression() {
    string ret = OpenMMSwigPINVOKE.CustomIntegrator_getKineticEnergyExpression(swigCPtr);
    return ret;
  }

  public void setKineticEnergyExpression(string expression) {
    OpenMMSwigPINVOKE.CustomIntegrator_setKineticEnergyExpression(swigCPtr, expression);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public int getRandomNumberSeed() {
    int ret = OpenMMSwigPINVOKE.CustomIntegrator_getRandomNumberSeed(swigCPtr);
    return ret;
  }

  public void setRandomNumberSeed(int seed) {
    OpenMMSwigPINVOKE.CustomIntegrator_setRandomNumberSeed(swigCPtr, seed);
  }

  public override void step(int steps) {
    OpenMMSwigPINVOKE.CustomIntegrator_step(swigCPtr, steps);
  }

  public enum ComputationType {
    ComputeGlobal = 0,
    ComputePerDof = 1,
    ComputeSum = 2,
    ConstrainPositions = 3,
    ConstrainVelocities = 4,
    UpdateContextState = 5,
    IfBlockStart = 6,
    WhileBlockStart = 7,
    BlockEnd = 8
  }

}

}
